import React, { useState, useEffect } from "react";
import socketIOClient from "socket.io-client";
import ApexChart from './ApexChart.js'
import useForceUpdate from 'use-force-update';
import ApexCharts from 'apexcharts';
import { PieChart } from 'react-minimal-pie-chart';

let ENDPOINT = "http://0.0.0.0:8080";
let globalArray=[];

let globalAttentive=0;
let globalNonAttentive=0;




function MotionDetectingClient(props) {
  console.log("Step 1")
  const [response, setResponse] = useState("");
 // const [arrayValues, setArrayValues] = useState(pieData);
  const [attention, setAttention] = useState(0);
  const [nonAttention, setNonAttention] = useState(0);
  const forceUpdate = useForceUpdate();

  const [,setState] = useState();

  useEffect(() => {
    if(props.server===undefined)
        { 
          console.log("No end point passed so using default end point = "+ENDPOINT)
        }
        else
        {
          ENDPOINT=props.server
          console.log("Using End point that is passed = "+ENDPOINT)
        }
        
    const socket = socketIOClient(ENDPOINT);
    /*socket.emit("message","TEST_MESSAGE");
    
    socket.on("FromAPI", data => {
      
      setResponse(data);
    });*/

    var localMediaStream = null;
    let video = document.querySelector("#videoElement");
    let canvas = document.querySelector("#canvasElement");
    let ctx = canvas.getContext('2d');

    function sendSnapshot() {

      // This is component did mount
     video = document.querySelector("#videoElement");
    
    
      if (!localMediaStream) {
        return;
      }
  
     ctx.drawImage(video, 0, 0, video.videoWidth, video.videoHeight, 0, 0, 300, 150);
  
      let dataURL = canvas.toDataURL('image/jpeg');
      
      socket.emit('input image', dataURL);
  
      socket.emit('output   ')
  
      //var img = new Image();
      socket.on('out-image-event',handler);

     
  
  
    }
    var constraints = {
      video: {
        width: { min: 640 },
        height: {  }
      }
    };
    navigator.mediaDevices.getUserMedia(constraints).then(function(stream) {
      video.srcObject = stream;
      localMediaStream = stream;
  
      setInterval(function () {
        sendSnapshot();
        forceUpdate();

      }, 3000);
    }).catch(function(error) {
      console.log(error);
    });


   

    return () => {
      console.log("Executing socket.off")
      socket.off('out-image-event', handler);
    }

    
  }, []);

  

  


  


  return (
    <div>
        <div style={{width:'100%', display:"flex"}}>  
          <video autoplay="true" id="videoElement" style={{width:'50%',height:'60%'}}></video>
           {/* <ApexChart id="chart" series={globalArray} style={{width:"500px",height:"500px",overfloxX:"scroll"}}></ApexChart>*/}
           <PieChart
        data={[
        { title: 'Keep Going', value: 100, color: '#808080' },
        { title: 'Attentive', value: attention, color: '#00FF00' },
        { title: 'Non Attentive', value: nonAttention, color: '#FF0000' }
        ]}
        radius="30"
        center={[50,40]}
        totalValue={attention+nonAttention}
/>
          <canvas id="canvasElement" style={{display:'none'}}></canvas>
                 </div>
        <h1>Circle will turn green if you remain attentive!</h1>
        </div>
  );

  function handler(data) { 
    console.log("MotionDetectingClientLog: you are moving a lot!!!");
    console.log(data);
    console.log("converting to number");
    //pieData.push(Number(data))
   //pieData.push(10000 - Number(data));
   //setArrayValues(...globalArray);
   //pieData.forEach(element => arrayValues.push(element));
   if(Number(data)<6000)
   {
     globalAttentive=globalAttentive+1
    console.log("attentive")
    setAttention(globalAttentive)
    if(globalNonAttentive!==0)
    globalNonAttentive = globalNonAttentive-1
    setNonAttention(globalNonAttentive)
   }
  else
  {
    globalNonAttentive = globalNonAttentive+1
   console.log("Non attentive")
   setNonAttention(globalNonAttentive)
    if(globalAttentive!==0)
   globalAttentive=globalAttentive-1
   setAttention(globalAttentive)
  }
    
   // console.log(globalArray);
    //console.log(arrayValues);
    setState({});
    if (props.callback === undefined) {
    }
    else {
      props.callback(data);
    }
  }

}

export default MotionDetectingClient;
